﻿<?php
/********************************************************************
  File : index.php
  Function : main program
  Version : 1.2

  This file is part of Goolag.
  Copyright 2005-2007 Alexis du Saussay
  http://www.asabox.com/goolag

  Goolag is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Goolag is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
********************************************************************
Release notes
November 2005: Initial Release
January 2007: Previous version was no longer working with the latest GDS version 5.
    a quick and dirty fix was made on line 226  
May 2015: Русская локализация
********************************************************************/

//====== URL to access your Google Desktop Search installation
$GDSurl = 'http://127.0.0.1:4664/search&s=k9m3NgRGSwTA6eGAQXheR2dpy88'; 

//============= don't modify below =========================

if ($GDSurl=='http://127.0.0.1:4664/search&s=<your key here>') {
	echo 'Missing configuration key.<br />';
	echo 'Please refer to the <a href="http://www.asabox.com/goolag" target="_blank">install doc</a>';
	die();
}

//------- Constants Definition  
define ('K_flagSortDate',0);
define ('K_flagSortRelevance',32);
define ('K_flagFilterAll',8);
define ('K_flagFilterWeb',256);
define ('K_flagFilterFiles',512);
define ('K_flagFilterMails',1024);
define ('K_flagFilterChats',2048);

include_once('fonctions.php');

$keyword = recupvariable('keyword');
// Добавил JT
$keyword=iconv('utf-8','windows-1251',$keyword); // эта функция покороче будет
//$keyword = mb_convert_encoding($keyword, 'CP1251', mb_detect_encoding($keyword)); работало вроде

$start = recupvariable('start',0);
$num = recupvariable('num',10);// было 10
$flagFilter = recupvariable('flagFilter',K_flagFilterAll);
$flagSort = recupvariable('flagSort',K_flagSortDate);
$flags = $flagFilter + $flagSort;

//------ display a result 
function afficheelement($txItem) {
	switch ($txItem->xCategory) {
		case 'web' :
			$url = $txItem->xUrl;
			break;
		case 'email':
			$url = 'mail.php?file='.urlencode($txItem->xCache_url);
			break;
		default:
			//$url = 'fichier.php?file='.urlencode($txItem->xUrl);//оригинал
			//$url = 'fichier.php?file='.($txItem->xUrl);
			//Добавим тут свое
			$file_path=$txItem->xUrl;
			$file_path=dirname($file_path);
			$file_path=str_replace('\\','/',$file_path);
			//$file_path=urlencode($file_path);
			$url = 'file:///'.strtolower($file_path).'/';
	}

	echo '<table cellspacing="0" cellpadding="10" class="reponse '.$txItem->xCategory.'">';
	echo '<tr><td width="30">';
	if (substr($txItem->xIcon,0,5)=='/icon') {
		echo '<img src="image.php?type=ico&amp;img='.urlencode($txItem->xIcon).'" alt="" class="ico" />';
	}
	else{
		echo '<img src="icon'.$txItem->xIcon.'" alt="" />';
	}
	echo '</td><td>';
	
	echo '<strong><a href="'.$url.'" target="_blank">'.($txItem->xTitle).'</a></strong>';
	if ($txItem->xCategory == 'file') echo '<br /><i>('.$txItem->xUrl.')</i>'; 
	echo '<br />';
	echo $txItem->xSnippet.'<br />';
	echo '<i>'.convertirdate($txItem->xTime).'</i>';
	echo '</td>';
	if ($txItem->xThumbnail!='') echo '<td width="140"><img src="image.php?type=png&amp;img='.urlencode($txItem->xThumbnail).'" alt="" class="thumb" /></td>';
	echo '</tr></table>'."\n";
}

class xItem {
  var $xCategory;
  var $xTitle;
  var $xUrl;
  var $xSnippet;
  var $xTime;
  var $xIcon;
  var $xThumbnail;
  var $xCache_url;
}

$nbTotalResultats = "0";
$arItems = array();
$itemCount = 0;

//-------------------------------------------------------------
function startElement($parser, $name, $attrs) {
  global $curTag, $nbTotalResultats;
  $numberKey = "COUNT";
  $curTag .= "^$name";
  if($curTag == "^RESULTS"){
      while(list($key, $value) = each($attrs)){
          if ($key == $numberKey) $nbTotalResultats = $value;
      }
  }
}

//-------------------------------------------------------------
function endElement($parser, $name) {
  global $curTag;
  $caret_pos = strrpos($curTag,'^');
  $curTag = substr($curTag,0,$caret_pos);
}

//-------------------------------------------------------------
function characterData($parser, $data) {
	global $curTag;
	global $arItems, $itemCount;
	switch ($curTag) {
		case '^RESULTS^RESULT^CATEGORY':
			 $itemCount++;
			 $arItems[$itemCount] = new xItem();
			 $arItems[$itemCount]->xCategory .= $data;
			 break;
		case '^RESULTS^RESULT^TITLE':
			$arItems[$itemCount]->xTitle .= $data;
			break;
		case '^RESULTS^RESULT^URL':
			$arItems[$itemCount]->xUrl .= $data;
			break;
		case '^RESULTS^RESULT^TIME':
			$arItems[$itemCount]->xTime .= $data;
			break;
		case '^RESULTS^RESULT^SNIPPET':
			$arItems[$itemCount]->xSnippet .= $data;
			break;
		case '^RESULTS^RESULT^ICON':
			$arItems[$itemCount]->xIcon .= $data;
			break;
		case '^RESULTS^RESULT^THUMBNAIL':
			$arItems[$itemCount]->xThumbnail .= $data;
			break;		
		case '^RESULTS^RESULT^CACHE_URL':
			$arItems[$itemCount]->xCache_url .= $data;
			break;
	}	
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="expires" content="-1">
<title>Поиск ПТО [<?php echo iconv('windows-1251','utf-8',$keyword);?>]</title>
<link rel="STYLESHEET" type="text/css" href="icon/goolag.css" />
</head>
<body>
<form  action="index.php" method="post" name="wsoogle">
<input TYPE="hidden"  name="start"  value="<?php echo $start;?>" />
<table class="toptable">
<tr>
<td width="275" height="30">&nbsp;</td>
<td width="450">
<input TYPE="text" name="keyword" SIZE="50" value="<?php echo iconv('windows-1251','utf-8',$keyword);?>" onchange="window.document.wsoogle.start.value='0';" />
<input TYPE="submit" name="search"  value="Поиск" />
</td>
<td>Выдавать по: <input type="text" name="num" value="<?php echo $num;?>" size="3" onchange="window.document.wsoogle.start.value='0';window.document.wsoogle.submit();" />
&nbsp;&nbsp;Сортировка: 
<select name="flagSort" size="1" onchange="window.document.wsoogle.start.value='0';window.document.wsoogle.submit();">
<?php
echo '<option value="'.K_flagSortDate.'" '.(($flags&K_flagSortDate)?' SELECTED':'').'>date</option>';
echo '<option value="'.K_flagSortRelevance.'" '.(($flags&K_flagSortRelevance)?' SELECTED':'').'>relevance</option>';
?>
</select>
&nbsp;&nbsp;Тип файла: 
<select name="flagFilter" size="1" onchange="window.document.wsoogle.start.value='0';window.document.wsoogle.submit();">
<?php
echo '<option value="'.K_flagFilterAll.'" '.(($flags&K_flagFilterAll)?' SELECTED':'').'>ALL</option>';
echo '<option value="'.K_flagFilterWeb.'" '.(($flags&K_flagFilterWeb)?' SELECTED':'').'>web</option>';
echo '<option value="'.K_flagFilterFiles.'" '.(($flags&K_flagFilterFiles)?' SELECTED':'').'>files</option>';
echo '<option value="'.K_flagFilterMails.'" '.(($flags&K_flagFilterMails)?' SELECTED':'').'>mails</option>';
echo '<option value="'.K_flagFilterChats.'" '.(($flags&K_flagFilterChats)?' SELECTED':'').'>chats</option>';
?>
</select> 
</td>
</tr>
<tr><td colspan="4"><i>Полнотекстовый поиск по папке <b>ПТО</b>. Для поиска введите слово или фразу. Чтобы найти <b>фразу целиком</b>, заключите ее в "кавычки".</i></td></tr>
<?php
//Определим браузер пользователя
  $user_agent = $_SERVER["HTTP_USER_AGENT"];
  if (strpos($user_agent, "Firefox") !== false) $browser = "Firefox";
  elseif (strpos($user_agent, "Opera") !== false) $browser = "Opera";
  elseif (strpos($user_agent, "Chrome") !== false) $browser = "Chrome";
  elseif (strpos($user_agent, "MSIE") !== false) $browser = "IExplorer";
  elseif (strpos($user_agent, "Safari") !== false) $browser = "Safari";
  else $browser = "Unknown";
  if ($browser !== 'IExplorer') echo '<tr><td colspan="4"><font color="red"><b>Неподдерживаемый браузер! Ссылки на папки с найденными файлами открываются только в Internet Explorer!</b></font></td></tr>'
?>
</table>
</form>

<?php 
if ($keyword == '') die('</body></html>'); 
//------- grab the XML and parse it
$GDSurl .= "?q=$keyword&num=$num&start=$start&flags=$flags&format=xml";

//echo "<hr>$GDSurl<hr>";

$xml_parser = xml_parser_create();
xml_set_element_handler($xml_parser, "startElement", "endElement");
xml_set_character_data_handler($xml_parser, "characterData");
if (!($fp = fopen($GDSurl,"r"))) die ("<b>Could not open XML for input.<br>Скорее всего, на PTO_MAIN не запущен Google Desktop Search.<br> Обратитесь к Начальнику ПТО.</b>");

//-- old version, no longer working since google desktop 5 
//while ($data = fread($fp, 4096)) { if (!xml_parse($xml_parser, $data, feof($fp))) die ('XML error');}

//-- new version
$xml=' ';
while ($data = fread($fp, 4096)) {$xml .= $data; }
$debutXml = strpos($xml,'<?xml');
$xml = substr ($xml,$debutXml);
if (!xml_parse($xml_parser, $xml)) die ('XML error');
xml_parser_free($xml_parser);

//------- blue bar with result count
echo '<table class="resultbar"><tr><td>';
if ($flags&K_flagFilterAll){
echo '<b>Все</b> результаты';
}
else {
	echo 'Только <b>';
	echo (($flags&K_flagFilterWeb)?' внешние WWW!':'');
	echo (($flags&K_flagFilterFiles)?'файлы!':'');
	echo (($flags&K_flagFilterMails)?' письма!':'');
	echo (($flags&K_flagFilterChats)?' чаты!':''); 
	echo '</b>';
}
echo '</td><td align="right"><b>'.$nbTotalResultats.'</b> результатов найдено</td></tr></table>';

//------- dump array for debugging purposes
/*
echo "<pre>";
print_r ($arItems);
echo "</pre>";
*/

//------- display all the results for this page
$nbResultatsPage = count($arItems);
while ($nbResultatsPage>0){
	afficheelement(array_shift($arItems));
	$nbResultatsPage--; 
} 
//Логгирование запросов к скрипту
writelog("Browser:".$browser."\t"." Items:".$nbTotalResultats."\t"." Key:".$keyword, "gds_search");

//------- Previous page/ Next page 
$nbPages = $nbTotalResultats/$num;
if ($nbPages!= intval($nbTotalResultats/$num)) $nbPages = intval($nbTotalResultats/$num)+1 ;
$pageCourante = ($start/$num)+1;
$pageMin = $pageCourante-9;
if ($pageMin<1) $pageMin=1;
$pageMax = $pageCourante+9;
if ($pageMax>$nbPages) $pageMax = $nbPages;
//Тут я тоже чет менял
$keyword = recupvariable('keyword');

if ($pageMax>$pageMin) {
	echo '<br /><div align="center" id="pageCount">Страниц:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
	if ($pageCourante>$pageMin) {
			$startValue = ($pageCourante-2)*$num;
			$urlPage = "index.php?keyword=$keyword&amp;start=$startValue&amp;num=$num&amp;flagFilter=$flagFilter&amp;flagSort=$flagSort";
			echo '<a href="'.$urlPage.'"><b>Назад</b></a>&nbsp;&nbsp;&nbsp;&nbsp;';
	}
	for($i=$pageMin;$i<=$pageMax;$i++){
		if ($i==$pageCourante) {
			echo '<b>'.$i.'</b>';
		}
		else {
			$startValue = ($i-1)*$num;
			$urlPage = "index.php?keyword=$keyword&amp;start=$startValue&amp;num=$num&amp;flagFilter=$flagFilter&amp;flagSort=$flagSort";
			echo '<a href="'.$urlPage.'">'.$i.'</a>';
		}
		echo '&nbsp;&nbsp;';
	}
	if ($pageCourante<$pageMax) {
			$startValue = $pageCourante*$num;
			$urlPage = "index.php?keyword=$keyword&amp;start=$startValue&amp;num=$num&amp;flagFilter=$flagFilter&amp;flagSort=$flagSort";
			echo '&nbsp;&nbsp;<a href="'.$urlPage.'"><b>Вперед</b></a>';
	}
	echo '</div>';
}
?>
<!-- HelloPreload -->
<style type="text/css">
#hellopreloader>p{
		display:none;
		}
#hellopreloader_preload{
		display: block;
		position: fixed;
		z-index: 99999;
		top: 0;
		left: 0;
		width: 100%;
		height: 100%;
		min-width: 1000px;
		background: #E4F1FE url(icon/anim.gif) center center no-repeat;
		background-size:101px;
		}
</style>
<div id="hellopreloader">
	<div id="hellopreloader_preload"></div>
	<p><a href="http://roskomstroy.com">Роскомстрой</a></p>
</div>
<script type="text/javascript">
var hellopreloader = document.getElementById("hellopreloader_preload");
function fadeOutnojquery(el){
	el.style.opacity = 1;
	var interhellopreloader = setInterval(function(){el.style.opacity = el.style.opacity - 0.05;
	if (el.style.opacity <=0){clearInterval(interhellopreloader);hellopreloader.style.display = "none";}
	},16);
	}
	window.onload = function(){
		setTimeout(function(){fadeOutnojquery(hellopreloader);},50);
	};
</script>
<!-- HelloPreload -->
</body></html>